//+------------------------------------------------------------------+
//|                                                       _asdfg.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property indicator_chart_window
extern bool Line_Restangle = true;
extern bool          Greed = false;
extern color        colore = Black; 
extern color        maxcol = Red; 
extern color        lincol = Silver;
int per;
void init(){
if(Period()==5)  per=1;
if(Period()==15) per=5;
if(Period()==30) per=15;
if(Period()==60) per=30;
if(Period()==240)per=60;
ObjectsDeleteAll();
return;}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   ObjectsDeleteAll();
   WindowRedraw();
   int i=MathRound((WindowPriceMax(0)-WindowPriceMin(0))/Point);
   int x;
   if(Greed){
     for(x=0;x<i;x++){
       SetHLine(lincol,"prise"+x,NormalizeDouble(WindowPriceMin(0)+(x*Point),Digits));
     }
   }
   int bars=WindowFirstVisibleBar();
   for(i=0;i<bars;i++){
     int pr=MathRound((High[i]-Low[i])/Point);
     for(x=1;x<=pr;x++){
       int y=(i*Period())+x;
       double z=x;
       int arr[];
       for(int a=1;a<=pr;a++){
         int b=(i*Period())+x;
         ArrayResize(arr,pr-1);
         arr[a-1]=iVolume(Symbol(),1,a*Period());
       }  
       int max=ArrayMaximum(arr);
       if(x==max){
         if(Line_Restangle){
           SetTLine(Lime,y+"Max"+i,Time[i],(Low[i]+z*Point),Time[i]+iVolume(Symbol(),1,y*Period())*10*Period(),(Low[i]+z*Point),DoubleToStr(iVolume(Symbol(),1,y*Period()),0),false); 
         }else{
           SetRestangle(DoubleToStr((i+1)*y,0)+"max",i+1,High[i]-(z*Point),i,High[i]-((z-1)*Point),maxcol," "+DoubleToStr(iVolume(Symbol(),1,y*Period()),0),true);
         }
       }else{ 
         if(Line_Restangle){ 
           SetTLine(DarkSlateGray,y+"bar"+i,Time[i],(Low[i]+z*Point),Time[i]+iVolume(Symbol(),1,y*Period())*10*Period(),(Low[i]+z*Point),DoubleToStr(iVolume(Symbol(),1,y*Period()),0));
         }else{
         SetRestangle(DoubleToStr((i+1)*y,0),i+1,High[i]-(z*Point),i,High[i]-((z-1)*Point),colore," "+DoubleToStr(iVolume(Symbol(),1,y*Period()),0),false);
         }
       }  
         ArrayInitialize(max,0); 
     }  
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+    
void SetTLine(color cl, string nm="",
              datetime t1=0, double p1=0, datetime t2=0, double p2=0,string tx="",bool back=true,
              bool ry=False, int st=0, int wd=1) {
  if (nm=="") nm=DoubleToStr(Time[0], 0);
  if (t1<=0) t1=Time[10];
  if (p1<=0) p1=Low[10];
  if (t2<=0) t2=Time[0];
  if (p2<=0) p2=Bid;
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_TREND, 0, 0,0, 0,0);
  ObjectSet(nm, OBJPROP_TIME1 , t1);
  ObjectSet(nm, OBJPROP_PRICE1, p1);
  ObjectSet(nm, OBJPROP_TIME2 , t2);
  ObjectSet(nm, OBJPROP_PRICE2, p2);
  ObjectSet(nm, OBJPROP_COLOR , cl);
  ObjectSet(nm, OBJPROP_RAY   , ry);
  ObjectSet(nm, OBJPROP_STYLE , st);
  ObjectSet(nm, OBJPROP_WIDTH , wd);
  ObjectSet(nm, OBJPROP_BACK , back);
  ObjectSetText(nm,tx,3);
}   
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
void SetRestangle(string nm,int bar1,double prs1,int bar2,double prs2,color col,string tx,bool fon){
  ObjectCreate(nm,OBJ_RECTANGLE,0,0,0,0,0,0,0);
  ObjectSet(nm,OBJPROP_TIME1,Time[bar1]);
  ObjectSet(nm,OBJPROP_PRICE1,prs1);
  ObjectSet(nm,OBJPROP_TIME2,Time[bar2]);
  ObjectSet(nm,OBJPROP_PRICE2,prs2); 
  ObjectSet(nm,OBJPROP_COLOR,col);
  ObjectSetText(nm, "   ", 5);
  ObjectSetText(nm, tx, 5); 
  if(!fon)ObjectSet(nm,OBJPROP_BACK,false);
  //WindowRedraw();
}  
void SetHLine(color cl, string nm="", double p1=0, int st=2, int wd=1) {
  if (nm=="") nm=DoubleToStr(Time[0], 0);
  if (p1<=0) p1=Bid;
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_HLINE, 0, 0,0);
  ObjectSet(nm, OBJPROP_PRICE1, p1);
  ObjectSet(nm, OBJPROP_COLOR , cl);
  ObjectSet(nm, OBJPROP_STYLE , st);
  ObjectSet(nm, OBJPROP_WIDTH , wd);
  ObjectSet(nm,OBJPROP_BACK,true);
}